#include <bits/stdc++.h>
using namespace std;

bool check(vector <int> v) {
    for (int i = 0; i + 1 < v.size(); i++) {
        if (v[i] > v[i + 1]) return 0;
    }

    return 1;
}

vector <int> get_front(vector <int> v, int idx) {
    int val = v[idx];

    v.erase(v.begin() + idx);
    v.insert(v.begin(), val);

    return v;
}

vector <int> get_back(vector <int> v, int idx) {
    int val = v[idx];

    v.erase(v.begin() + idx);
    v.push_back(val);

    return v;
}

map <vector <int>, int> t;

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;

    vector <int> v;

    for (int i = 1; i <= n; i++) {
        int x;
        cin >> x;

        v.push_back(x);
    }

    queue <vector <int>> q;
    t[v] = 1;
    q.push(v);

    while (q.size()) {
        auto top = q.front();
        q.pop();

        if (check(top)) {
            cout << t[top] - 1 << endl;
            return 0;
        }

        for (int i = 0; i < n; i++) {
            const auto& v_front = get_front(top, i);
            const auto& v_back = get_back(top, i);

            if (t[v_front] == 0) {
                t[v_front] = t[top] + 1;
                q.push(v_front);
            }

            if (t[v_back] == 0) {
                t[v_back] = t[top] + 1;
                q.push(v_back);
            }
        }
    }

    return 0;

}
