#include <bits/stdc++.h>
using namespace std;

const long long MAXN = 3e5 + 10;
long long a[MAXN], last[MAXN], first[MAXN], cnt[MAXN];

void compress(long long* begin, long long* end) {
    vector <pair <long long, long long*>> v;
    long long compress_cnt = 1;

    for (auto it = begin; it != end; it++) {
        v.push_back({*it, it});
    }

    sort(v.begin(), v.end());
    fill(first, first + v.size() + 10, INT_MAX);

    for (long long i = 0; i < v.size(); i++) {
        (*v[i].second) = compress_cnt;
        cnt[compress_cnt]++;

        first[*v[i].second] = min(first[*v[i].second], (long long) (v[i].second - begin + 1));
        last[*v[i].second] = max(last[*v[i].second], (long long) (v[i].second - begin + 1));
        if (i + 1 == v.size() || v[i].first != v[i + 1].first) compress_cnt++;
    }
}

unordered_map <long long, long long> dp;
vector <long long> positions[MAXN];

int main() {

    first[0] = last[0] = 0;

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    long long n, ans = 0;
    cin >> n;

    for (long long i = 1; i <= n; i++) {
        cin >> a[i];
    }

    compress(a + 1, a + n + 1);
    long long mx = 0;

    for (long long i = 1; i <= n; i++) {
        positions[a[i]].push_back(i);
        mx = max(mx, a[i]);
    }

    for (long long i = 1; i <= mx; i++) {
        sort(positions[i].begin(), positions[i].end());
    }

    /**for (long long i = 1; i <= n; i++) {
        dp[0][a[i]]++;
        dp[1][a[i]] = max(dp[0][a[i] - 1], dp[1][a[i]]) + 1;

        if (dp[2][a[i]]) dp[2][a[i]]++;
        else if (last[a[i] - 1] <= i) dp[2][a[i]] = max(dp[1][a[i] - 1], dp[3][a[i] - 1]) + 1;

        if (i == last[a[i]]) dp[3][a[i]] = dp[2][a[i]];

        if (dp[a[i]] == 0) {
            if (last[a[i] - 1] < i) dp[a[i]] = dp[a[i] - 1] + 1;
            else dp[a[i]] = 1;
        } else {
            dp[a[i]]++;
        }

        cout << a[i] << ' ' << dp[0][a[i]] << ' ' << dp[1][a[i]] << ' ' << dp[2][a[i]] << endl;

        ans = max({ans, dp[0][a[i]], dp[1][a[i]], dp[2][a[i]]});
    }*/

    for (long long i = 1; i <= n; i++) {
        if (first[i] > last[i - 1]) {
            dp[i] = cnt[i] + dp[i - 1];
        } else dp[i] = cnt[i] + (long long) (lower_bound(positions[i - 1].begin(), positions[i - 1].end(), first[i]) - positions[i - 1].begin());
        ans = max(ans, dp[i] + (long long) (positions[i + 1].end() - lower_bound(positions[i + 1].begin(), positions[i + 1].end(), last[i])));
    }

    cout << n - ans << endl;
    return 0;

}
