#include <bits/stdc++.h>
using namespace std;

const int MAXN = 2e5 + 10;
bool sieve[MAXN];
long long prefix[MAXN];

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;

    for (int i = 2; i * i <= n; i++) {
        for (int j = i; j <= n; j += i) {
            sieve[i * j] = 1;
        }
    }

    for (int i = 1; i <= n; i++) {
        prefix[i] = prefix[i - 1] + (sieve[i] == 0);
    }

    long long ans = 0;

    for (int c = 1; c * c <= n; c++) {
        long long amount = (c - 1) * (c - 2) / 2;

        ans += amount * prefix[n / c / c];
    }

    cout << ans << endl;
    return 0;

}
