#include<iostream>
#include<vector>
#include<algorithm>
#include<map>
using namespace std;

int main()
{
    int n;
    cin>>n;

    vector<int> arr(n);
    for(int i=0; i<n; i++){
        cin >> arr[i];
    }

    vector<int> sorted_arr= arr;
    sort(sorted_arr.begin(), sorted_arr.end());

    map<int, int> position;
    for(int i=0; i<n; i++){
        position[sorted_arr[i]] = i;
    }

    vector<bool> visited(n, false);
    int operations = 0;

    for(int i=0; i<n; i++){
        if(visited[i] || position[arr[i]] == i) {
            continue;
        }

        int cycle_lenght=0;
        int current=i;

        while(!visited[current]){
            visited[current] = true;
            current = position[arr[current]];
            cycle_lenght++;
        }

        if(cycle_lenght>1){
            operations+=cycle_lenght-1;
        }

cout<<operations<<endl;
return 0;


}
