#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <string>
#include <cstring>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <map>
#define endl '\n'
using namespace std;
set <long long> s;
void fill_s(int n)
{
    for(int i = 1; i <= n; i++)
    {
        s.insert(i*i);
    }
}
long long root(long long a, long long& l)
{
    //cout << a << " - ";
    int del = 2;
    long long root = 1, cnt = 0;
    while(a > 1)
    {
        while(a%del == 0)
        {
            cnt++;
            if(cnt %2 == 1)
            {
                l*=del;
            }
            else
            {
                l /= del;
                root *= del;
            }
            //cout << del << ";" << root << " ";
            a /= del;
        }
        if(del == 2)del ++;
        else del += 2;
        cnt = 0;
    }
    //cout << endl;
    return root;
}
long long nod(long long a, long long b)
{
    while(a*b)
    {
        if(a >= b)a %= b;
        else b %= a;
    }
    return a+b;
}
long long nok(long long a, long long b)
{
    return a*b/nod(a, b);
}
int main()
{
   ios_base::sync_with_stdio(false);
   cin.tie(0);
   cout.tie(0);
   int n;
   cin >> n;
   fill_s(n);
   long long cnt = 0;
   for(int a = 1; a <= n-2; a++)
   {
       for(int b = a+1; b < n; b++)
       {
           if(s.find(a*b) != s.end())
           {
               long long la = 1, lb = 1;
               long long ra = root(a, la);
               long long rb = root(b, lb);
               long long c = nok(la, lb);
              // cout << a << " " << b << " " << la << " " << lb << " " << rb << endl;
               while(c*rb*rb <= n)
               {
                   if(c*rb*rb > b)cnt++;
                   rb++;
               }
           }
       }
   }
   cout << cnt << endl;
   return 0;
}
