#include <bits/stdc++.h>
using namespace std;

const int MAXN = 3e5 + 10;
int a[MAXN], last[MAXN];

void compress(int* begin, int* end) {
    vector <pair <int, int*>> v;
    int compress_cnt = 1;

    for (auto it = begin; it != end; it++) {
        v.push_back({*it, it});
    }

    sort(v.begin(), v.end());

    for (int i = 0; i < v.size(); i++) {
        (*v[i].second) = compress_cnt;
        last[*v[i].second] = max((long long) last[*v[i].second], v[i].second - begin + 1);
        if (i + 1 == v.size() || v[i].first != v[i + 1].first) compress_cnt++;
    }
}

unordered_map <int, int> dp[3];

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, ans = 0;
    cin >> n;


    for (int i = 1; i <= n; i++) {
        cin >> a[i];
    }

    compress(a + 1, a + n + 1);


    for (int i = 1; i <= n; i++) {
        dp[0][a[i]]++;
        dp[1][a[i]] = max(dp[0][a[i] - 1], dp[1][a[i]]) + 1;

        if (dp[2][a[i]]) dp[2][a[i]]++;
        else if (last[a[i] - 1] < i) dp[2][a[i]] = max(dp[1][a[i] - 1], dp[2][a[i] - 1]) + 1;

        /**if (dp[a[i]] == 0) {
            if (last[a[i] - 1] < i) dp[a[i]] = dp[a[i] - 1] + 1;
            else dp[a[i]] = 1;
        } else {
            dp[a[i]]++;
        }*/

        //cout << a[i] << ' ' << dp[0][a[i]] << ' ' << dp[1][a[i]] << ' ' << dp[2][a[i]] << endl;

        ans = max({ans, dp[0][a[i]], dp[1][a[i]], dp[2][a[i]]});
    }

    cout << n - ans << endl;
    return 0;

}
